<!-- This Source Code Form is subject to the terms of the Mozilla Public
   - License, v. 2.0. If a copy of the MPL was not distributed with this
   - file, You can obtain one at http://mozilla.org/MPL/2.0/. -->

<panel id="appMenu-popup"
       class="cui-widget-panel panel-no-padding"
       role="group"
       type="arrow"
       hidden="true"
       flip="slide"
       position="bottomcenter topright"
       noautofocus="true">
  <panelmultiview id="appMenu-multiView"
                  mainViewId="appMenu-mainView"
                  viewCacheId="appMenu-viewCache">

    <!-- Main Appmenu View -->
    <panelview id="appMenu-mainView" class="PanelUI-subView"
               descriptionheightworkaround="true">
      <vbox id="appMenu-mainViewItems"
            class="panel-subview-body">
        <vbox id="appMenu-addon-banners"/>
        <toolbarbutton class="panel-banner-item"
                       label-update-available="updateAvailable.panelUI.label"
                       label-update-manual="updateManual.panelUI.label"
                       label-update-unsupported="updateUnsupported.panelUI.label"
                       label-update-restart="updateRestart.panelUI.label2"
                       oncommand="PanelUI._onBannerItemSelected(event)"
                       wrap="true"
                       hidden="true"/>
        <toolbarbutton id="appmenu_new"
                       class="subviewbutton subviewbutton-iconic subviewbutton-nav"
                       label="&newMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-newView', this)"/>
        <toolbarbutton id="appmenu_msgAttachmentMenu"
                       class="subviewbutton subviewbutton-iconic subviewbutton-nav"
                       label="&openAttachmentListCmd.label;"
                       disabled="true"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-attachmentsView', this)"/>
        <toolbarseparator/>
        <toolbaritem id="appmenu-edit-controls"
                     class="toolbaritem-combined-buttons"
                     closemenu="none">
          <!-- Use a spacer, because panel sizing code gets confused when using CSS methods. -->
          <spacer class="before-label"/>
          <label value="&appmenuEditMenu.label;"/>
          <!-- This spacer keeps the scrollbar from overlapping the view. -->
          <spacer class="after-label"/>

          <toolbarbutton id="appmenu-cut"
                         class="subviewbutton subviewbutton-iconic"
                         command="cmd_cut"
                         tooltip="dynamic-shortcut-tooltip"/>
          <toolbarbutton id="appmenu-copy"
                         class="subviewbutton subviewbutton-iconic"
                         command="cmd_copy"
                         tooltip="dynamic-shortcut-tooltip"/>
          <toolbarbutton id="appmenu-paste"
                         class="subviewbutton subviewbutton-iconic"
                         command="cmd_paste"
                         tooltip="dynamic-shortcut-tooltip"/>
          <toolbarseparator orient="vertical"/>
          <toolbarbutton id="appmenu-edit-button"
                         class="subviewbutton subviewbutton-nav"
                         closemenu="none"
                         oncommand="PanelUI.showSubView('appMenu-editView', this)"/>
        </toolbaritem>
        <toolbarseparator/>
        <toolbarbutton id="appmenu_find"
                       class="subviewbutton subviewbutton-nav subviewbutton-iconic"
                       label="&findMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-findView', this)"/>
        <toolbarbutton id="appmenu_print"
                       class="subviewbutton subviewbutton-iconic"
                       label="&printCmd.label;"
                       key="key_print"
                       command="cmd_print"/>
        <toolbarbutton id="appmenu_saveAs"
                       class="subviewbutton subviewbutton-nav subviewbutton-iconic"
                       label="&saveAsMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-saveAsView', this)"/>
        <toolbarbutton id="appmenu_emptyTrash"
                       class="subviewbutton subviewbutton-iconic"
                       label="&emptyTrashCmd.label;"
                       command="cmd_emptyTrash"/>
        <toolbarseparator/>
        <toolbarbutton id="appmenu_addons"
                       class="subviewbutton subviewbutton-iconic"
                       data-l10n-id="appmenu-addons-and-themes"
                       closemenu="none"
                       oncommand="openAddonsMgr();"/>
        <toolbarbutton id="appmenu_accountmgr"
                       class="subviewbutton subviewbutton-iconic"
                       label="&accountManagerCmd2.label;"
                       oncommand="MsgAccountManager(null);"/>
        <toolbarbutton id="appmenu_preferences"
                       class="subviewbutton subviewbutton-iconic"
                       data-l10n-id="appmenu-settings"
                       closemenu="none"
                       oncommand="openOptionsDialog();"/>
        <toolbarseparator/>
        <toolbarbutton id="appmenu_File"
                       class="subviewbutton subviewbutton-nav"
                       label="&fileMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-fileView', this)"/>
        <toolbarbutton id="appmenu_View"
                       class="subviewbutton subviewbutton-nav"
                       label="&viewMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-viewView', this)"/>
        <toolbarbutton id="appmenu_Go"
                       class="subviewbutton subviewbutton-nav"
                       label="&goMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-goView', this)"/>
        <toolbarbutton id="appmenu_messageMenu"
                       class="subviewbutton subviewbutton-nav"
                       label="&msgMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-messageView', this)"/>
#ifdef MAIN_WINDOW
        <toolbarbutton id="appmenu_Event_Task"
                       class="subviewbutton subviewbutton-nav hide-when-calendar-deactivated"
                       label="&lightning.menu.eventtask.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appmenu_Event_Task_View', this)"/>
#endif
        <toolbarbutton id="appmenu_tasksMenu"
                       class="subviewbutton subviewbutton-nav"
                       label="&tasksMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-toolsView', this)"/>
        <toolbarbutton id="appmenu_help"
                       class="subviewbutton subviewbutton-iconic subviewbutton-nav"
                       label="&helpMenuWin.label;"
                       closemenu="none"
                       oncommand="buildHelpMenu(); PanelUI.showSubView('appMenu-helpView', this)"/>

        <toolbarseparator/>
        <toolbarbutton id="appmenu-quit"
                       class="subviewbutton subviewbutton-iconic"
#ifdef XP_WIN
                       label="&quitApplicationCmd.label;"
#else
                       label="&quitApplicationCmdUnix.label;"
#endif
                       command="cmd_quit"/>
      </vbox>
    </panelview>

    <!-- New -->
    <panelview id="appMenu-newView"
               title="&newMenu.label;"
               class="PanelUI-subView">
      <vbox id="appMenu-newViewItems"
            class="panel-subview-body">
        <toolbarbutton id="appmenu_newNewMsgCmd"
                       class="subviewbutton subviewbutton-iconic"
                       label="&newNewMsgCmd.label;"
                       key="key_newMessage2"
                       command="cmd_newMessage"/>
#ifdef MAIN_WINDOW
        <toolbarbutton id="appmenu_calendar-new-event-menu-item"
                       class="subviewbutton subviewbutton-iconic hide-when-calendar-deactivated"
                       label="&lightning.menupopup.new.event.label;"
                       command="calendar_new_event_command"/>
        <toolbarbutton id="appmenu_calendar-new-task-menu-item"
                       class="subviewbutton subviewbutton-iconic hide-when-calendar-deactivated"
                       label="&lightning.menupopup.new.task.label;"
                       command="calendar_new_todo_command"/>
        <toolbarseparator id="appmenu_calendar-after-new-task-separator"
                          class="hide-when-calendar-deactivated"
                          observes="appmenu_newFolder"/>
#endif
        <toolbarbutton id="appmenu_newFolder"
                       class="subviewbutton subviewbutton-iconic"
                       label="&newFolderCmd.label;"
                       command="cmd_newFolder"/>
        <toolbarbutton id="appmenu_newVirtualFolder"
                       class="subviewbutton subviewbutton-iconic"
                       label="&newVirtualFolderCmd.label;"
                       command="cmd_newVirtualFolder"/>
        <toolbarseparator id="appmenu_newAccountPopupMenuSeparator"/>
        <toolbarbutton id="appmenu_newCreateEmailAccountMenuItem"
                       class="subviewbutton subviewbutton-iconic"
                       label="&newCreateEmailAccountCmd.label;"
                       oncommand="openAccountProvisionerTab();"/>
        <toolbarbutton id="appmenu_newMailAccountMenuItem"
                       class="subviewbutton subviewbutton-iconic"
                       label="&newExistingEmailAccountCmd.label;"
                       oncommand="openAccountSetupTab();"/>
        <toolbarbutton id="appmenu_newIMAccountMenuItem"
                       class="subviewbutton subviewbutton-iconic"
                       label="&newIMAccountCmd.label;"
                       oncommand="openIMAccountWizard();"/>
        <toolbarbutton id="appmenu_newFeedAccountMenuItem"
                       class="subviewbutton subviewbutton-iconic"
                       label="&newFeedAccountCmd.label;"
                       accesskey="&newFeedAccountCmd.accesskey;"
                       oncommand="AddFeedAccount();"/>
        <toolbarbutton id="appmenu_newNewsgroupAccountMenuItem"
                       class="subviewbutton subviewbutton-iconic"
                       data-l10n-id="file-new-newsgroup-account"
                       oncommand="openNewsgroupAccountWizard();"/>
#ifdef MAIN_WINDOW
        <toolbarbutton id="appmenu_calendar-new-calendar-menu-item"
                       class="subviewbutton subviewbutton-iconic"
                       label="&lightning.menupopup.new.calendar.label;"
                       command="calendar_new_calendar_command"/>
#endif
        <toolbarseparator id="appmenu_newPopupMenuSeparator"/>
        <toolbarbutton id="appmenu_newCard"
                       class="subviewbutton subviewbutton-iconic"
                       label="&appmenuNewContactCmd.label;"
                       command="cmd_newCard"/>
        <toolbarbutton id="appmenu_newIMContactMenuItem"
                       class="subviewbutton subviewbutton-iconic"
                       label="&newIMContactCmd.label;"
                       command="cmd_addChatBuddy"/>
      </vbox>
    </panelview>

    <!-- Attachments -->
    <panelview id="appMenu-attachmentsView"
               title="&openAttachmentListCmd.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <!-- A toolbarbutton for each attachment is added here when this view is shown. -->
        <toolbarseparator/>
        <toolbarbutton label="&openAllAttachmentsCmd.label;"
                       class="subviewbutton subviewbutton-iconic"
                       accesskey="&openAllAttachmentsCmd.accesskey;"
                       command="cmd_openAllAttachments"/>
        <toolbarbutton label="&saveAllAttachmentsCmd.label;"
                       class="subviewbutton subviewbutton-iconic"
                       accesskey="&saveAllAttachmentsCmd.accesskey;"
                       command="cmd_saveAllAttachments"/>
        <toolbarbutton label="&detachAllAttachmentsCmd.label;"
                       class="subviewbutton subviewbutton-iconic"
                       accesskey="&detachAllAttachmentsCmd.accesskey;"
                       command="cmd_detachAllAttachments"/>
        <toolbarbutton label="&deleteAllAttachmentsCmd.label;"
                       class="subviewbutton subviewbutton-iconic"
                       accesskey="&deleteAllAttachmentsCmd.accesskey;"
                       command="cmd_deleteAllAttachments"/>
      </vbox>
    </panelview>

    <!-- Attachment (single attachment view) -->
    <panelview id="appMenu-attachmentView"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <!-- toolbarbutton elements are added here when this view is shown (open, save, etc.). -->
      </vbox>
    </panelview>

    <!-- Edit -->
    <panelview id="appMenu-editView"
               title="&appmenuEditMenu.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu-editmenu-cut"
                       class="subviewbutton subviewbutton-iconic"
                       data-l10n-id="text-action-cut"
                       key="key_cut"
                       command="cmd_cut"/>
        <toolbarbutton id="appmenu-editmenu-copy"
                       class="subviewbutton subviewbutton-iconic"
                       data-l10n-id="text-action-copy"
                       key="key_copy"
                       command="cmd_copy"/>
        <toolbarbutton id="appmenu-editmenu-paste"
                       class="subviewbutton subviewbutton-iconic"
                       data-l10n-id="text-action-paste"
                       key="key_paste"
                       command="cmd_paste"/>
        <toolbarseparator/>
        <toolbarbutton id="appmenu-editmenu-undo"
                       class="subviewbutton subviewbutton-iconic"
                       data-l10n-id="text-action-undo"
                       key="key_undo"
                       command="cmd_undo"/>
        <toolbarbutton id="appmenu-editmenu-redo"
                       class="subviewbutton subviewbutton-iconic"
                       data-l10n-id="text-action-redo"
                       key="key_redo"
                       command="cmd_redo"/>
        <toolbarseparator id="appmenu_messageAfterRedoEditSeparator"/>
        <toolbarbutton id="appmenu_delete"
                       class="subviewbutton subviewbutton-iconic"
                       data-l10n-id="text-action-delete"
#ifdef XP_MACOSX
                       acceltext="⌫"
#else
                       key="key_delete"
#endif
                       command="cmd_delete"/>
        <toolbarseparator id="appmenu_messageAfterDeleteEditSeparator"/>
        <toolbarbutton id="appmenu-editmenu-selectAll"
                       class="subviewbutton subviewbutton-iconic"
                       data-l10n-id="text-action-select-all"
                       key="key_selectAll"
                       command="cmd_selectAll"/>
        <toolbarbutton id="appmenu_selectThread"
                       class="subviewbutton subviewbutton-iconic"
                       label="&appmenuSelectThread.label;"
                       key="key_selectThread"
                       command="cmd_selectThread"/>
        <toolbarbutton id="appmenu_selectFlagged"
                       class="subviewbutton subviewbutton-iconic"
                       label="&appmenuSelectFlagged.label;"
                       command="cmd_selectFlagged"/>
      </vbox>
    </panelview>

    <!-- Find -->
    <panelview id="appMenu-findView"
               title="&findMenu.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_findCmd"
                       class="subviewbutton subviewbutton-iconic"
                       label="&findCmd.label;"
                       key="key_find"
                       command="cmd_find"/>
        <toolbarbutton id="appmenu_findAgainCmd"
                       class="subviewbutton subviewbutton-iconic"
                       label="&findAgainCmd.label;"
                       key="key_findAgain"
                       command="cmd_findAgain"/>
        <toolbarseparator id="appMenuAfterFindSeparator"/>
        <toolbarbutton id="appmenu_searchMailCmd"
                       class="subviewbutton subviewbutton-iconic"
                       label="&searchMailCmd.label;"
                       key="key_searchMail"
                       command="cmd_search"/>
        <toolbarbutton id="appmenu_glodaSearchCmd"
                       class="subviewbutton subviewbutton-iconic"
                       label="&glodaSearchCmd.label;"
                       oncommand="openGlodaSearchTab()"/>
        <toolbarbutton id="appmenu_searchAddressesCmd"
                       class="subviewbutton subviewbutton-iconic"
                       label="&searchAddressesCmd.label;"
                       oncommand="MsgSearchAddresses()"/>
      </vbox>
    </panelview>

    <!-- Save As -->
    <panelview id="appMenu-saveAsView"
               title="&saveAsMenu.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_saveAsFile"
                       class="subviewbutton subviewbutton-iconic"
                       data-l10n-id="appmenu-save-as-file"
                       key="key_saveAsFile"
                       command="cmd_saveAsFile"/>
        <toolbarbutton id="appmenu_saveAsTemplate"
                       class="subviewbutton subviewbutton-iconic"
                       label="&saveAsTemplateCmd.label;"
                       command="cmd_saveAsTemplate"/>
      </vbox>
    </panelview>

    <!-- View / Toolbars -->
    <panelview id="appMenu-toolbarsView"
               title="&viewToolbarsMenu.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
#ifdef MAIN_WINDOW
        <toolbarbutton id="appmenu_quickFilterBar"
                       class="subviewbutton subviewbutton-iconic"
                       type="checkbox"
                       label="&quickFilterBar.toggleBarVisibility.appmenu.label;"
                       closemenu="none"
                       command="cmd_toggleQuickFilterBar"/>
        <toolbarbutton id="appmenu_spacesToolbar"
                       class="subviewbutton subviewbutton-iconic"
                       type="checkbox"
                       data-l10n-id="menu-spaces-toolbar-button"
                       closemenu="none"
                       oncommand="gSpacesToolbar.toggleToolbarFromMenu();"/>
#endif
        <toolbarbutton id="appmenu_showStatusbar"
                       class="subviewbutton subviewbutton-iconic"
                       type="checkbox"
                       label="&showTaskbarCmd.label;"
                       oncommand="goToggleToolbar('status-bar', 'menu_showTaskbar')"
                       closemenu="none"
                       checked="true"
                       observes="menu_showTaskbar"/>
        <toolbarseparator id="appmenu_toggleToolbarsSeparator"/>
        <toolbarbutton id="appmenu_toolbarLayout"
                       class="subviewbutton subviewbutton-iconic"
                       label="&appmenuToolbarLayout.label;"
                       command="cmd_CustomizeMailToolbar"/>
      </vbox>
    </panelview>

    <!-- View / UI Density -->
    <panelview id="appMenu_uiDensityView"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_uiDensityCompact"
                       class="subviewbutton subviewbutton-iconic"
                       data-l10n-id="mail-uidensity-compact"
                       type="radio"
                       closemenu="none"
                       oncommand="PanelUI.setUIDensity(event);"/>
        <toolbarbutton id="appmenu_uiDensityNormal"
                       class="subviewbutton subviewbutton-iconic"
                       data-l10n-id="mail-uidensity-normal"
                       type="radio"
                       closemenu="none"
                       oncommand="PanelUI.setUIDensity(event);"/>
        <toolbarbutton id="appmenu_uiDensityTouch"
                       class="subviewbutton subviewbutton-iconic"
                       data-l10n-id="mail-uidensity-touch"
                       type="radio"
                       closemenu="none"
                       oncommand="PanelUI.setUIDensity(event);"/>
      </vbox>
    </panelview>

    <!-- View / Layout -->
    <panelview id="appMenu-preferencesLayoutView"
               title="&messagePaneLayoutStyle.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_messagePaneClassic"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       label="&messagePaneClassic.label;"
                       name="viewlayoutgroup"
                       command="cmd_viewClassicMailLayout"/>
        <toolbarbutton id="appmenu_messagePaneWide"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       label="&messagePaneWide.label;"
                       name="viewlayoutgroup"
                       command="cmd_viewWideMailLayout"/>
        <toolbarbutton id="appmenu_messagePaneVertical"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       label="&messagePaneVertical.label;"
                       name="viewlayoutgroup"
                       command="cmd_viewVerticalMailLayout"/>
        <toolbarseparator id="appmenu_viewMenuAfterPaneVerticalSeparator"/>
        <toolbarbutton id="appmenu_showFolderPane"
                       class="subviewbutton subviewbutton-iconic"
                       type="checkbox"
                       label="&showFolderPaneCmd.label;"
                       command="cmd_toggleFolderPane"/>
        <toolbarbutton id="appmenu_showFolderPaneCols"
                       class="subviewbutton subviewbutton-iconic"
                       type="checkbox"
                       label="&showFolderPaneColsCmd.label;"
                       command="cmd_toggleFolderPaneCols"/>
        <toolbarbutton id="appmenu_showMessage"
                       class="subviewbutton subviewbutton-iconic"
                       type="checkbox"
                       label="&showMessageCmd.label;"
                       key="key_toggleMessagePane"
                       command="cmd_toggleMessagePane"/>
      </vbox>
    </panelview>

    <!-- File -->
    <panelview id="appMenu-fileView"
               title="&fileMenu.label;"
               class="PanelUI-subView">
      <vbox id="appMenu-fileViewItems"
            class="panel-subview-body">
        <toolbarbutton id="appmenu_Open"
                       class="subviewbutton subviewbutton-nav"
                       mode="calendar"
                       label="&openMenuCmd.label;"
                       closemenu="none"
                       accesskey="&openMenuCmd.accesskey;"
                       oncommand="PanelUI.showSubView('appMenu-fileOpenView', this)"/>
        <toolbarbutton id="appmenu_close"
                       class="subviewbutton subviewbutton-iconic"
                       label="&closeCmd.label;"
                       key="key_close"
                       command="cmd_close"/>
        <toolbarseparator id="appmenu_fileMenuAfterCloseSeparator"/>
        <toolbarbutton id="appmenu_getNewMsgFor"
                       class="subviewbutton subviewbutton-nav"
                       label="&getNewMsgForCmd.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-fileGetNewMsgForView', this)"/>
        <toolbarbutton id="appmenu_getNextNMsgs"
                       class="subviewbutton subviewbutton-iconic"
                       label="&getNextNMsgCmd2.label;"
                       command="cmd_getNextNMessages"/>
        <toolbarbutton id="appmenu_sendUnsentMsgs"
                       class="subviewbutton subviewbutton-iconic"
                       label="&sendUnsentCmd.label;"
                       command="cmd_sendUnsentMsgs"/>
        <toolbarbutton id="appmenu_subscribe"
                       class="subviewbutton subviewbutton-iconic"
                       label="&subscribeCmd.label;"
                       command="cmd_subscribe"/>
        <toolbarseparator id="appmenu_fileMenuAfterSubscribeSeparator"/>
        <toolbarbutton id="appmenu_deleteFolder"
                       class="subviewbutton subviewbutton-iconic"
                       label="&deleteFolder.label;"
                       command="cmd_deleteFolder"/>
        <toolbarbutton id="appmenu_renameFolder"
                       class="subviewbutton subviewbutton-iconic"
                       label="&renameFolder.label;"
#ifndef XP_MACOSX
                       key="key_renameFolder"
#endif
                       command="cmd_renameFolder"/>
        <toolbarseparator id="appmenu_fileMenuAfterRenameSeparator"/>
        <toolbarbutton id="appmenu_compactFolder"
                       class="subviewbutton subviewbutton-iconic"
                       label="&compactFolders.label;"
                       command="cmd_compactFolder"/>
        <toolbarseparator id="appmenu_fileMenuAfterCompactSeparator"/>
        <toolbarbutton id="appmenu_offline"
                       class="subviewbutton subviewbutton-nav"
                       label="&offlineMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-fileOfflineView', this)"/>
      </vbox>
    </panelview>

    <!-- File / Open -->
    <panelview id="appMenu-fileOpenView"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_OpenMessageFileMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       label="&openMessageFileCmd.label;"
                       accesskey="&openMessageFileCmd.accesskey;"
                       oncommand="MsgOpenFromFile();"/>
        <toolbarbutton id="appmenu_OpenCalendarFileMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       label="&lightning.menupopup.open.calendar.label;"
                       accesskey="&lightning.menupopup.open.calendar.accesskey;"
                       oncommand="openLocalCalendar();"/>
      </vbox>
    </panelview>

    <!-- File / Get New Message For -->
    <panelview is="folder-panelview" id="appMenu-fileGetNewMsgForView"
               title="&getNewMsgForCmd.label;"
               class="PanelUI-subView"
               mode="getMail"
               expandFolders="false"
               oncommand="MsgGetMessagesForAccount(event.target._folder); event.stopPropagation();">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_getnewmsgs_all_accounts"
                       class="subviewbutton subviewbutton-iconic"
                       label="&getAllNewMsgCmdPopupMenu.label;"
                       key="key_getAllNewMessages"
                       command="cmd_getMsgsForAuthAccounts"/>
        <toolbarbutton id="appmenu_getnewmsgs_current_account"
                       class="subviewbutton subviewbutton-iconic"
                       label="&getNewMsgCurrentAccountCmdPopupMenu.label;"
                       key="key_getNewMessages"
                       command="cmd_getNewMessages"/>
        <toolbarseparator/>
        <!-- toolbarbuttons are dynamically added here by folder-panelview custom element. -->
      </vbox>
    </panelview>

    <!-- File / Offline -->
    <panelview id="appMenu-fileOfflineView"
               title="&offlineMenu.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_goOffline"
                       class="subviewbutton subviewbutton-iconic"
                       type="checkbox"
                       label="&offlineGoOfflineCmd.label;"
                       oncommand="MailOfflineMgr.toggleOfflineStatus();"/>
        <toolbarseparator id="appmenu_offlineMenuAfterGoSeparator"/>
        <toolbarbutton id="appmenu_synchronizeOffline"
                       class="subviewbutton subviewbutton-iconic"
                       label="&synchronizeOfflineCmd.label;"
                       command="cmd_synchronizeOffline"/>
        <toolbarbutton id="appmenu_settingsOffline"
                       class="subviewbutton subviewbutton-iconic"
                       label="&settingsOfflineCmd2.label;"
                       command="cmd_settingsOffline"/>
        <toolbarseparator id="app_offlineMenuAfterSettingsSeparator"/>
        <toolbarbutton id="appmenu_downloadFlagged"
                       class="subviewbutton subviewbutton-iconic"
                       label="&downloadStarredCmd.label;"
                       command="cmd_downloadFlagged"/>
        <toolbarbutton id="appmenu_downloadSelected"
                       class="subviewbutton subviewbutton-iconic"
                       label="&downloadSelectedCmd.label;"
                       command="cmd_downloadSelected"/>
      </vbox>
    </panelview>

    <!-- View -->
    <panelview id="appMenu-viewView"
               title="&viewMenu.label;"
               class="PanelUI-subView">
      <vbox id="appMenu-viewViewItems"
            class="panel-subview-body">
        <toolbarbutton id="appmenu_Toolbars"
                       class="subviewbutton subviewbutton-nav"
                       label="&viewToolbarsMenu.label;"
                       accesskey="&viewToolbarsMenu.accesskey;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-toolbarsView', this)"/>
        <toolbarbutton id="appmenu_MessagePaneLayout"
                       class="subviewbutton subviewbutton-nav"
                       label="&messagePaneLayoutStyle.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-preferencesLayoutView', this)"/>
        <toolbarbutton id="appmenu_FolderViews"
                       class="subviewbutton subviewbutton-nav"
                       label="&folderView.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-foldersView', this)"/>
        <toolbarseparator/>
        <toolbarbutton id="appmenu_uiDensity"
                       class="subviewbutton subviewbutton-nav"
                       data-l10n-id="mail-uidensity-label"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu_uiDensityView', this)"/>
        <toolbarbutton id="appmenu_viewFullZoomMenu"
                       class="subviewbutton subviewbutton-nav"
                       label="&fullZoom.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-viewZoomView', this)"/>
        <toolbaritem id="appMenu-fontSize-controls"
                     class="subviewbutton toolbaritem-combined-buttons"
                     closemenu="none">
          <label class="toolbarbutton-text" data-l10n-id="appmenu-font-size-value"/>
          <toolbarbutton id="appMenu-fontSizeReduce-button"
                         class="subviewbutton subviewbutton-iconic"
                         command="cmd_fontSizeReduce"
                         data-l10n-id="appmenuitem-font-size-reduce"/>
          <toolbarbutton id="appMenu-fontSizeReset-button"
                         class="subviewbutton"
                         command="cmd_fontSizeReset"
                         tooltip="fontSizeReset"/>
          <toolbarbutton id="appMenu-fontSizeEnlarge-button"
                         class="subviewbutton subviewbutton-iconic"
                         command="cmd_fontSizeEnlarge"
                         data-l10n-id="appmenuitem-font-size-enlarge"/>
        </toolbaritem>
#ifdef MAIN_WINDOW
        <toolbarseparator id="appmenu_calendar-view-menu-separator"
                          class="hide-when-calendar-deactivated"/>
        <toolbarbutton id="appmenu_calendar-today-pane-menu"
                      class="subviewbutton subviewbutton-nav hide-when-calendar-deactivated"
                      label="&calendar.context.button.label;"
                      closemenu="none"
                      oncommand="PanelUI.showSubView('appmenu_calendar-today-pane-view', this)"/>
        <toolbarbutton id="appmenu_calendar-calendar-menu"
                      class="subviewbutton subviewbutton-nav hide-when-calendar-deactivated"
                      observes="calendar_in_foreground"
                      label="&lightning.menu.view.calendar.label;"
                      closemenu="none"
                      oncommand="PanelUI.showSubView('appmenu_calendar-calendar-view', this)"/>
        <toolbarbutton id="appmenu_calendar-tasks-menu"
                      class="subviewbutton subviewbutton-nav hide-when-calendar-deactivated"
                      observes="calendar_mode_task"
                      label="&lightning.menu.view.tasks.label;"
                      closemenu="none"
                      oncommand="PanelUI.showSubView('appmenu_calendar-tasks-view', this)"/>
#endif
        <toolbarseparator id="appmenu_viewSortMenuSeparator"/>
        <toolbarbutton id="appmenu_viewSortMenu"
                       class="subviewbutton subviewbutton-nav"
                       label="&sortMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-viewSortByView', this)"/>
        <toolbarbutton id="appmenu_viewMessageViewMenu"
                       class="subviewbutton subviewbutton-nav"
                       label="&msgsMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-viewMessagesView', this)"/>
        <toolbarbutton id="appmenu_viewMessagesMenu"
                       class="subviewbutton subviewbutton-nav"
                       label="&threads.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-viewThreadsView', this)"/>
        <toolbarbutton id="appmenu_viewHeadersMenu"
                       class="subviewbutton subviewbutton-nav"
                       label="&headersMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-viewHeadersView', this)"/>
        <toolbarbutton id="appmenu_viewBodyMenu"
                       class="subviewbutton subviewbutton-nav"
                       label="&bodyMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-viewMessageBodyAsView', this)"/>
        <toolbarbutton id="appmenu_viewFeedSummary"
                       class="subviewbutton subviewbutton-nav"
                       label="&bodyMenuFeed.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-viewFeedsView', this)"/>
        <toolbarbutton id="appmenu_viewAttachmentsInlineMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       label="&viewAttachmentsInlineCmd.label;"
                       oncommand="ToggleInlineAttachment(event.target)"
                       type="checkbox"
                       checked="true"/>
        <toolbarseparator id="appmenu_viewAfterAttachmentsSeparator"/>
        <toolbarbutton id="appmenu_charsetRepairMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       data-l10n-id="repair-text-encoding-button"
                       oncommand="MailSetCharacterSet()"/>
        <toolbarseparator id="appmenu_viewAfterCharsetSeparator"/>
        <toolbarbutton id="appmenu_pageSourceMenuItem"
                       class="subviewbutton subviewbutton-iconic"
                       label="&pageSourceCmd.label;"
                       key="key_viewPageSource"
                       command="cmd_viewPageSource"/>
      </vbox>
    </panelview>

    <!-- View / Folders -->
    <panelview id="appMenu-foldersView"
               title="&folderView.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_allFolders"
                       class="subviewbutton subviewbutton-iconic"
                       value="all"
                       label="&allFolders.label;"
                       type="checkbox"
                       name="viewmessages"
                       closemenu="none"
                       oncommand="PanelUI.folderViewMenuOnCommand(event);"/>
        <toolbarbutton id="appmenu_smartFolders"
                       class="subviewbutton subviewbutton-iconic"
                       value="smart"
                       label="&unifiedFolders.label;"
                       type="checkbox"
                       name="viewmessages"
                       closemenu="none"
                       oncommand="PanelUI.folderViewMenuOnCommand(event);"/>
        <toolbarbutton id="appmenu_unreadFolders"
                       class="subviewbutton subviewbutton-iconic"
                       value="unread"
                       label="&unreadFolders.label;"
                       type="checkbox"
                       name="viewmessages"
                       closemenu="none"
                       oncommand="PanelUI.folderViewMenuOnCommand(event);"/>
        <toolbarbutton id="appmenu_favoriteFolders"
                       class="subviewbutton subviewbutton-iconic"
                       value="favorite"
                       label="&favoriteFolders.label;"
                       type="checkbox"
                       name="viewmessages"
                       closemenu="none"
                       oncommand="PanelUI.folderViewMenuOnCommand(event);"/>
        <toolbarbutton id="appmenu_recentFolders"
                       class="subviewbutton subviewbutton-iconic"
                       value="recent"
                       label="&recentFolders.label;"
                       type="checkbox"
                       name="viewmessages"
                       closemenu="none"
                       oncommand="PanelUI.folderViewMenuOnCommand(event);"/>
        <toolbarseparator id="appmenu_favoritePropertiesSeparator"/>
        <toolbarbutton id="appmenu_compactMode"
                       class="subviewbutton subviewbutton-iconic"
                       value="compact"
                       label="&compactVersion.label;"
                       type="checkbox"
                       name="viewmessages"
                       closemenu="none"
                       oncommand="PanelUI.folderCompactMenuOnCommand(event)"/>
        <toolbarseparator id="appmenu_favoritePropertiesSeparator"/>
        <toolbarbutton id="appmenu_favoriteFolder"
                       class="subviewbutton subviewbutton-iconic"
                       type="checkbox"
                       label="&menuFavoriteFolder.label;"
                       checked="false"
                       oncommand="ToggleFavoriteFolderFlag();"/>
        <toolbarbutton id="appmenu_properties"
                       class="subviewbutton subviewbutton-iconic"
                       label="&folderPropsCmd2.label;"
                       command="cmd_properties"/>
      </vbox>
    </panelview>

    <!-- View / Sort by -->
    <panelview id="appMenu-viewSortByView"
               title="&sortMenu.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_sortByDateMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="sortby"
                       label="&sortByDateCmd.label;"
                       oncommand="MsgSortThreadPane('byDate')"/>
        <toolbarbutton id="appmenu_sortByReceivedMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="sortby"
                       label="&sortByReceivedCmd.label;"
                       oncommand="MsgSortThreadPane('byReceived')"/>
        <toolbarbutton id="appmenu_sortByFlagMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="sortby"
                       label="&sortByStarCmd.label;"
                       oncommand="MsgSortThreadPane('byFlagged')"/>
        <toolbarbutton id="appmenu_sortByOrderReceivedMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="sortby"
                       label="&sortByOrderReceivedCmd.label;"
                       oncommand="MsgSortThreadPane('byId')"/>
        <toolbarbutton id="appmenu_sortByPriorityMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="sortby"
                       label="&sortByPriorityCmd.label;"
                       oncommand="MsgSortThreadPane('byPriority')"/>
        <toolbarbutton id="appmenu_sortByFromMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="sortby"
                       label="&sortByFromCmd.label;"
                       oncommand="MsgSortThreadPane('byAuthor')"/>
        <toolbarbutton id="appmenu_sortByRecipientMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="sortby"
                       label="&sortByRecipientCmd.label;"
                       oncommand="MsgSortThreadPane('byRecipient')"/>
        <toolbarbutton id="appmenu_sortByCorrespondentMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="sortby"
                       label="&sortByCorrespondentCmd.label;"
                       oncommand="MsgSortThreadPane('byCorrespondent')"/>
        <toolbarbutton id="appmenu_sortBySizeMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="sortby"
                       label="&sortBySizeCmd.label;"
                       oncommand="MsgSortThreadPane('bySize')"/>
        <toolbarbutton id="appmenu_sortByStatusMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="sortby"
                       label="&sortByStatusCmd.label;"
                       oncommand="MsgSortThreadPane('byStatus')"/>
        <toolbarbutton id="appmenu_sortBySubjectMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="sortby"
                       label="&sortBySubjectCmd.label;"
                       oncommand="MsgSortThreadPane('bySubject')"/>
        <toolbarbutton id="appmenu_sortByUnreadMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="sortby"
                       label="&sortByUnreadCmd.label;"
                       oncommand="MsgSortThreadPane('byUnread')"/>
        <toolbarbutton id="appmenu_sortByTagsMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="sortby"
                       label="&sortByTagsCmd.label;"
                       oncommand="MsgSortThreadPane('byTags')"/>
        <toolbarbutton id="appmenu_sortByJunkStatusMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="sortby"
                       label="&sortByJunkStatusCmd.label;"
                       oncommand="MsgSortThreadPane('byJunkStatus')"/>
        <toolbarbutton id="appmenu_sortByAttachmentsMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="sortby"
                       label="&sortByAttachmentsCmd.label;"
                       oncommand="MsgSortThreadPane('byAttachments')"/>
        <toolbarseparator id="appmenu_sortAfterAttachmentSeparator"/>
        <toolbarbutton id="appmenu_sortAscending"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="sortdirection"
                       label="&sortAscending.label;"
                       oncommand="MsgSortAscending()"/>
        <toolbarbutton id="appmenu_sortDescending"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="sortdirection"
                       label="&sortDescending.label;"
                       oncommand="MsgSortDescending()"/>
        <toolbarseparator id="appmenu_sortAfterDescendingSeparator"/>
        <toolbarbutton id="appmenu_sortThreaded"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="threaded"
                       label="&sortThreaded.label;"
                       oncommand="MsgSortThreaded();"/>
        <toolbarbutton id="appmenu_sortUnthreaded"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="threaded"
                       label="&sortUnthreaded.label;"
                       oncommand="MsgSortUnthreaded();"/>
        <toolbarbutton id="appmenu_groupBySort"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="group"
                       label="&groupBySort.label;"
                       oncommand="MsgGroupBySort();"/>
      </vbox>
    </panelview>

    <!-- View / Messages -->
    <panelview id="appMenu-viewMessagesView"
               title="&msgsMenu.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_viewMessageAll"
                       class="subviewbutton subviewbutton-iconic"
                       value="0"
                       type="radio"
                       label="&viewAll.label;"
                       oncommand="ViewChangeByMenuitem(event.target);"/>
        <toolbarbutton id="appmenu_viewMessageUnread"
                       class="subviewbutton subviewbutton-iconic"
                       value="1"
                       type="radio"
                       label="&viewUnread.label;"
                       oncommand="ViewChangeByMenuitem(event.target);"/>
        <toolbarbutton id="appmenu_viewMessageNotDeleted"
                       class="subviewbutton subviewbutton-iconic"
                       value="3"
                       type="radio"
                       label="&viewNotDeleted.label;"
                       oncommand="ViewChangeByMenuitem(event.target);"/>
        <toolbarseparator id="appmenu_messageViewAfterUnreadSeparator"/>
        <toolbarbutton id="appmenu_viewMessageTags"
                       class="subviewbutton subviewbutton-nav"
                       label="&viewTags.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-viewMessagesTagsView', this)"/>
        <toolbarbutton id="appmenu_viewMessageCustomViews"
                       class="subviewbutton subviewbutton-nav"
                       label="&viewCustomViews.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-viewMessagesCustomViewsView', this)"/>
        <toolbarseparator id="appmenu_messageViewAfterCustomSeparator"/>
        <toolbarbutton id="appmenu_viewMessageVirtualFolder"
                       class="subviewbutton subviewbutton-iconic"
                       value="7"
                       label="&viewVirtualFolder.label;"
                       oncommand="ViewChangeByMenuitem(event.target);"/>
        <toolbarbutton id="appmenu_viewMessageCustomize"
                       class="subviewbutton subviewbutton-iconic"
                       value="8"
                       label="&viewCustomizeView.label;"
                       oncommand="ViewChangeByMenuitem(event.target);"/>
      </vbox>
    </panelview>

    <!-- View / Messages / Tags -->
    <!-- Dynamically populated when shown. -->
    <panelview id="appMenu-viewMessagesTagsView"
               title="&viewTags.label;"
               class="PanelUI-subView"
               oncommand="ViewChangeByMenuitem(event.target);">
      <vbox class="panel-subview-body"/>
    </panelview>

    <!-- View / Messages / Custom Views -->
    <!-- Dynamically populated when shown. -->
    <panelview id="appMenu-viewMessagesCustomViewsView"
               title="&viewCustomViews.label;"
               class="PanelUI-subView"
               oncommand="ViewChangeByMenuitem(event.target);">
      <vbox class="panel-subview-body"/>
    </panelview>

    <!-- View / Threads -->
    <panelview id="appMenu-viewThreadsView"
               title="&threads.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_viewAllMessagesMenuItem"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="viewmessages"
                       label="&allMsgsCmd.label;"
                       disabled="true"
                       command="cmd_viewAllMsgs"/>
        <toolbarbutton id="appmenu_viewUnreadMessagesMenuItem"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="viewmessages"
                       label="&unreadMsgsCmd.label;"
                       disabled="true"
                       command="cmd_viewUnreadMsgs"/>
        <toolbarbutton id="appmenu_viewThreadsWithUnreadMenuItem"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="viewmessages"
                       label="&threadsWithUnreadCmd.label;"
                       disabled="true"
                       command="cmd_viewThreadsWithUnread"/>
        <toolbarbutton id="appmenu_viewWatchedThreadsWithUnreadMenuItem"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="viewmessages"
                       label="&watchedThreadsWithUnreadCmd.label;"
                       disabled="true"
                       command="cmd_viewWatchedThreadsWithUnread"/>
        <toolbarseparator id="appmenu_threadsAfterWatchedSeparator"/>
        <toolbarbutton id="appmenu_viewIgnoredThreadsMenuItem"
                       class="subviewbutton subviewbutton-iconic"
                       type="checkbox"
                       label="&ignoredThreadsCmd.label;"
                       disabled="true"
                       command="cmd_viewIgnoredThreads"/>
        <toolbarseparator id="appmenu_threadsAfterIgnoredSeparator"/>
        <toolbarbutton id="appmenu_expandAllThreads"
                       class="subviewbutton subviewbutton-iconic"
                       label="&expandAllThreadsCmd.label;"
                       key="key_expandAllThreads"
                       disabled="true"
                       command="cmd_expandAllThreads"/>
        <toolbarbutton id="appmenu_collapseAllThreads"
                       class="subviewbutton subviewbutton-iconic"
                       label="&collapseAllThreadsCmd.label;"
                       key="key_collapseAllThreads"
                       disabled="true"
                       command="cmd_collapseAllThreads"/>
      </vbox>
    </panelview>

    <!-- View / Headers -->
    <panelview id="appMenu-viewHeadersView"
               title="&headersMenu.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_viewallheaders"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="viewheadergroup"
                       label="&headersAllCmd.label;"
                       command="cmd_viewAllHeader"/>
        <toolbarbutton id="appmenu_viewnormalheaders"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="viewheadergroup"
                       label="&headersNormalCmd.label;"
                       command="cmd_viewNormalHeader"/>
      </vbox>
    </panelview>

    <!-- View / Message Body As -->
    <panelview id="appMenu-viewMessageBodyAsView"
               title="&bodyMenu.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_bodyAllowHTML"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="bodyPlaintextVsHTMLPref"
                       label="&bodyAllowHTML.label;"
                       oncommand="MsgBodyAllowHTML()"/>
        <toolbarbutton id="appmenu_bodySanitized"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="bodyPlaintextVsHTMLPref"
                       label="&bodySanitized.label;"
                       oncommand="MsgBodySanitized()"/>
        <toolbarbutton id="appmenu_bodyAsPlaintext"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="bodyPlaintextVsHTMLPref"
                       label="&bodyAsPlaintext.label;"
                       oncommand="MsgBodyAsPlaintext()"/>
        <toolbarbutton id="appmenu_bodyAllParts"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="bodyPlaintextVsHTMLPref"
                       label="&bodyAllParts.label;"
                       oncommand="MsgBodyAllParts()"/>
      </vbox>
    </panelview>

    <!-- View / Feed Message Body As -->
    <panelview id="appMenu-viewFeedsView"
               title="&bodyMenuFeed.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_bodyFeedGlobalWebPage"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="viewFeedSummaryGroup"
                       label="&viewFeedWebPage.label;"
                       observes="bodyFeedGlobalWebPage"
                       oncommand="FeedMessageHandler.onSelectPref = 0"/>
        <toolbarbutton id="appmenu_bodyFeedGlobalSummary"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="viewFeedSummaryGroup"
                       label="&viewFeedSummary.label;"
                       observes="bodyFeedGlobalSummary"
                       oncommand="FeedMessageHandler.onSelectPref = 1"/>
        <toolbarbutton id="appmenu_bodyFeedPerFolderPref"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="viewFeedSummaryGroup"
                       label="&viewFeedSummaryFeedPropsPref.label;"
                       observes="bodyFeedPerFolderPref"
                       oncommand="FeedMessageHandler.onSelectPref = 2"/>
        <toolbarseparator id="appmenu_viewFeedSummarySeparator"/>
        <toolbarbutton id="appmenu_bodyFeedSummaryAllowHTML"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="viewFeedBodyHTMLGroup"
                       label="&bodyAllowHTML.label;"
                       oncommand="MsgFeedBodyRenderPrefs(false, 0, 0)"/>
        <toolbarbutton id="appmenu_bodyFeedSummarySanitized"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="viewFeedBodyHTMLGroup"
                       label="&bodySanitized.label;"
                       oncommand="MsgFeedBodyRenderPrefs(false, 3, gDisallow_classes_no_html)"/>
        <toolbarbutton id="appmenu_bodyFeedSummaryAsPlaintext"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="viewFeedBodyHTMLGroup"
                       label="&bodyAsPlaintext.label;"
                       oncommand="MsgFeedBodyRenderPrefs(true, 1, gDisallow_classes_no_html)"/>
      </vbox>
    </panelview>

    <!-- View / Zoom -->
    <panelview id="appMenu-viewZoomView"
               title="&fullZoom.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_fullZoomEnlarge"
                       class="subviewbutton subviewbutton-iconic"
                       label="&fullZoomEnlargeCmd.label;"
                       key="key_fullZoomEnlarge"
                       command="cmd_fullZoomEnlarge"/>
        <toolbarbutton id="appmenu_fullZoomReduce"
                       class="subviewbutton subviewbutton-iconic"
                       label="&fullZoomReduceCmd.label;"
                       key="key_fullZoomReduce"
                       command="cmd_fullZoomReduce"/>
        <toolbarseparator id="appmenu_fullZoomAfterReduceSeparator"/>
        <toolbarbutton id="appmenu_fullZoomReset"
                       class="subviewbutton subviewbutton-iconic"
                       label="&fullZoomResetCmd.label;"
                       key="key_fullZoomReset"
                       command="cmd_fullZoomReset"/>
        <toolbarseparator id="appmenu_fullZoomAfterResetSeparator"/>
        <toolbarbutton id="appmenu_fullZoomToggle"
                       class="subviewbutton subviewbutton-iconic"
                       label="&fullZoomToggleCmd.label;"
                       type="checkbox"
                       command="cmd_fullZoomToggle"
                       checked="false"/>
      </vbox>
    </panelview>

    <!-- Go -->
    <panelview id="appMenu-goView"
               title="&goMenu.label;"
               class="PanelUI-subView">
      <vbox id="appMenu-goViewItems"
            class="panel-subview-body">
        <toolbarbutton id="appmenu_goNextMenu"
                       class="subviewbutton subviewbutton-nav"
                       label="&nextMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-goNextView', this)"/>
        <toolbarbutton id="appmenu_goPreviousMenu"
                       class="subviewbutton subviewbutton-nav"
                       label="&prevMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-goPreviousView', this)"/>
        <toolbarbutton id="appmenu_goForward"
                       class="subviewbutton subviewbutton-iconic"
                       label="&goForwardCmd.label;"
                       key="key_goForward"
                       command="cmd_goForward"/>
        <toolbarbutton id="appmenu_goBack"
                       class="subviewbutton subviewbutton-iconic"
                       label="&goBackCmd.label;"
                       key="key_goBack"
                       command="cmd_goBack"/>
        <toolbarseparator id="appmenu_goNextSeparator"/>
#ifdef MAIN_WINDOW
        <toolbarbutton id="appmenu_calendar-go-to-today"
                       class="subviewbutton subviewbutton-iconic hide-when-calendar-deactivated"
                       label="&goTodayCmd.label;"
                       command="calendar_go_to_today_command"/>
#endif
        <toolbarbutton id="appmenu_goChat"
                       class="subviewbutton subviewbutton-iconic"
                       label="&goChatCmd.label;"
                       command="cmd_chat"/>
        <toolbarseparator id="appmenu_goChatSeparator"/>
        <toolbarbutton id="appmenu_goFolderMenu"
                       class="subviewbutton subviewbutton-nav"
                       label="&folderMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-goFolderView', this)"/>
        <toolbarseparator id="appmenu_goFolderSeparator"/>
        <toolbarbutton id="appmenu_goRecentlyClosedTabs"
                       class="subviewbutton subviewbutton-nav"
                       label="&goRecentlyClosedTabs.label;"
                       observes="cmd_undoCloseTab"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-goRecentlyClosedTabsView', this)"/>
        <toolbarseparator id="appmenu_goRecentlyClosedTabsSeparator"/>
        <toolbarbutton id="appmenu_goStartPage"
                       class="subviewbutton subviewbutton-iconic"
                       label="&startPageCmd.label;"
                       key="key_goStartPage"
                       command="cmd_goStartPage"/>
      </vbox>
    </panelview>

    <!-- Go / Next -->
    <panelview id="appMenu-goNextView"
               title="&nextMenu.label;"
               class="PanelUI-subView">
      <vbox id="appMenu-goNextViewItems"
            class="panel-subview-body">
        <toolbarbutton id="appmenu_nextMsg"
                       class="subviewbutton subviewbutton-iconic"
                       label="&nextMsgCmd.label;"
                       key="key_nextMsg"
                       command="cmd_nextMsg"/>
        <toolbarbutton id="appmenu_nextUnreadMsg"
                       class="subviewbutton subviewbutton-iconic"
                       label="&nextUnreadMsgCmd.label;"
                       key="key_nextUnreadMsg"
                       command="cmd_nextUnreadMsg"/>
        <toolbarbutton id="appmenu_nextFlaggedMsg"
                       class="subviewbutton subviewbutton-iconic"
                       label="&nextStarredMsgCmd.label;"
                       command="cmd_nextFlaggedMsg"/>
        <toolbarseparator id="appmenu_goNextAfterFlaggedSeparator"/>
        <toolbarbutton id="appmenu_nextUnreadThread"
                       class="subviewbutton subviewbutton-iconic"
                       label="&nextUnreadThread.label;"
                       key="key_nextUnreadThread"
                       command="cmd_nextUnreadThread"/>
#ifdef MAIN_WINDOW
        <toolbarseparator id="appmenu_GoNextAfterUnreadThreadSeparator"
                          class="hide-when-calendar-deactivated"/>
        <!-- Label is set up automatically using the view id. When writing a
             view extension, add a `label-<myviewtype>` attribute with the
             correct label. -->
        <toolbarbutton id="appmenu_calendar-go-menu-next"
                       class="subviewbutton subviewbutton-iconic hide-when-calendar-deactivated"
                       label=""
                       label-day="&lightning.toolbar.day.label;"
                       label-week="&lightning.toolbar.week.label;"
                       label-multiweek="&lightning.toolbar.week.label;"
                       label-month="&lightning.toolbar.month.label;"
                       command="calendar_view_next_command"/>
#endif
      </vbox>
    </panelview>

    <!-- Go / Previous -->
    <panelview id="appMenu-goPreviousView"
               title="&prevMenu.label;"
               class="PanelUI-subView">
      <vbox id="appMenu-goPreviousViewItems"
            class="panel-subview-body">
        <toolbarbutton id="appmenu_prevMsg"
                       class="subviewbutton subviewbutton-iconic"
                       label="&prevMsgCmd.label;"
                       key="key_previousMsg"
                       command="cmd_previousMsg"/>
        <toolbarbutton id="appmenu_prevUnreadMsg"
                       class="subviewbutton subviewbutton-iconic"
                       label="&prevUnreadMsgCmd.label;"
                       key="key_previousUnreadMsg"
                       command="cmd_previousUnreadMsg"/>
        <toolbarbutton id="appmenu_prevFlaggedMsg"
                       class="subviewbutton subviewbutton-iconic"
                       label="&prevStarredMsgCmd.label;"
                       command="cmd_previousFlaggedMsg"/>
#ifdef MAIN_WINDOW
        <toolbarseparator id="appmenu_goPreviousAfterFlaggedSeparator"
                          class="hide-when-calendar-deactivated"/>
        <!-- Label is set up automatically using the view id. When writing a
             view extension, add a `label-<myviewtype>` attribute with the
             correct label. -->
        <toolbarbutton id="appmenu_calendar-go-menu-previous"
                       class="subviewbutton subviewbutton-iconic hide-when-calendar-deactivated"
                       label=""
                       label-day="&lightning.toolbar.day.label;"
                       label-week="&lightning.toolbar.week.label;"
                       label-multiweek="&lightning.toolbar.week.label;"
                       label-month="&lightning.toolbar.month.label;"
                       command="calendar_view_prev_command"/>
#endif
      </vbox>
    </panelview>

    <!-- Go / Folder -->
    <!-- toolbarbuttons are dynamically added by folder-panelview custom element. -->
    <panelview is="folder-panelview" id="appMenu-goFolderView"
               title="&folderMenu.label;"
               class="PanelUI-subView"
               showFileHereLabel="true"
               showRecent="true"
               showFavorites="true"
               command="cmd_goFolder"
               recentLabel="&contextMoveCopyMsgRecentMenu.label;"
               favoritesLabel="&contextMoveCopyMsgFavoritesMenu.label;"/>

    <!-- Go / Recently Closed Tabs -->
    <!-- Dynamically populated when shown. -->
    <panelview id="appMenu-goRecentlyClosedTabsView"
               title="&goRecentlyClosedTabs.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body"/>
    </panelview>


    <!-- Message -->
    <panelview id="appMenu-messageView"
               title="&msgMenu.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_newMsgCmd"
                       class="subviewbutton subviewbutton-iconic"
                       label="&newMsgCmd.label;"
                       key="key_newMessage2"
                       command="cmd_newMessage"/>
        <toolbarbutton id="appmenu_replyMainMenu"
                       class="subviewbutton subviewbutton-iconic"
                       label="&replyMsgCmd.label;"
                       key="key_reply"
                       command="cmd_reply"/>
        <toolbarbutton id="appmenu_replyNewsgroupMainMenu"
                       class="subviewbutton subviewbutton-iconic"
                       label="&replyNewsgroupCmd2.label;"
                       key="key_reply"
                       command="cmd_replyGroup"/>
        <toolbarbutton id="appmenu_replySenderMainMenu"
                       class="subviewbutton subviewbutton-iconic"
                       label="&replySenderCmd.label;"
                       command="cmd_replySender"/>
        <toolbarbutton id="appmenu_replyToAll"
                       class="subviewbutton subviewbutton-iconic"
                       label="&replyToAllMsgCmd.label;"
                       key="key_replyall"
                       command="cmd_replyall"/>
        <toolbarbutton id="appmenu_replyToList"
                       class="subviewbutton subviewbutton-iconic"
                       label="&replyToListMsgCmd.label;"
                       key="key_replylist"
                       command="cmd_replylist"/>
        <toolbarbutton id="appmenu_forwardMsg"
                       class="subviewbutton subviewbutton-iconic"
                       label="&forwardMsgCmd.label;"
                       key="key_forward"
                       command="cmd_forward"/>
        <toolbarbutton id="appmenu_forwardAsMenu"
                       class="subviewbutton subviewbutton-nav"
                       label="&forwardAsMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-messageForwardAsView', this)"/>
        <toolbarbutton id="appmenu_redirectMsg"
                       data-l10n-id="appmenu-redirect-msg"
                       class="subviewbutton subviewbutton-iconic"
                       command="cmd_redirect"/>
        <toolbarbutton id="appmenu_editMsgAsNew"
                       class="subviewbutton subviewbutton-iconic"
                       label="&editAsNewMsgCmd.label;"
                       key="key_editAsNew"
                       command="cmd_editAsNew"/>
        <toolbarbutton id="appmenu_editDraftMsg"
                       class="subviewbutton subviewbutton-iconic"
                       label="&editDraftMsgCmd.label;"
                       command="cmd_editDraftMsg"/>
        <toolbarbutton id="appmenu_newMsgFromTemplateCmd"
                       class="subviewbutton subviewbutton-iconic"
                       label="&newMsgFromTemplateCmd.label;"
                       key="key_newMsgFromTemplate"
                       command="cmd_newMsgFromTemplate"/>
        <toolbarbutton id="appmenu_editTemplateMsgCmd"
                       class="subviewbutton subviewbutton-iconic"
                       label="&editTemplateMsgCmd.label;"
                       command="cmd_editTemplateMsg"/>
        <toolbarseparator id="appmenu_messageMenuAfterCompositionCommandsSeparator"/>
        <toolbarbutton id="appmenu_openMessageWindowMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       label="&openMessageWindowCmd.label;"
                       key="key_openMessage"
                       command="cmd_openMessage"/>
#ifdef MAIN_WINDOW
        <toolbarbutton id="appmenu_openConversationMenuitem"
                       class="subviewbutton subviewbutton-iconic"
                       label="&openInConversationCmd.label;"
                       key="key_openConversation"
                       command="cmd_openConversation"/>
#endif
        <toolbarbutton id="appmenu_openFeedMessage"
                       class="subviewbutton subviewbutton-nav"
                       label="&openFeedMessage1.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-messageOpenFeedView', this)"/>
#ifdef MAIN_WINDOW
        <toolbarseparator id="appmenu_messageAfterOpenMsgSeparator"/>
#endif
        <toolbarbutton id="appmenu_tagMenu"
                       class="subviewbutton subviewbutton-nav"
                       label="&tagMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-messageTagView', this)"/>
        <toolbarbutton id="appmenu_markMenu"
                       class="subviewbutton subviewbutton-nav"
                       label="&markMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-messageMarkView', this)"/>
        <toolbarseparator id="appmenu_messageMenuAfterMarkSeparator"/>
        <toolbarbutton id="appmenu_archiveMainMenu"
                       class="subviewbutton subviewbutton-iconic"
                       label="&archiveMsgCmd.label;"
                       key="key_archive"
                       command="cmd_archive"/>
        <toolbarbutton id="appmenu_cancel"
                       class="subviewbutton subviewbutton-iconic"
                       command="cmd_cancel"
                       label="&cancelNewsMsgCmd.label;"/>
        <toolbarbutton id="appmenu_moveMenu"
                       class="subviewbutton subviewbutton-nav"
                       label="&moveMsgToMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-messageMoveToView', this)"/>
        <toolbarbutton id="appmenu_copyMenu"
                       class="subviewbutton subviewbutton-nav"
                       label="&copyMsgToMenu.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-messageCopyToView', this)"/>
        <toolbarbutton id="appmenu_moveToFolderAgain"
                       class="subviewbutton subviewbutton-iconic"
                       command="cmd_moveToFolderAgain"
                       key="key_moveToFolderAgain"
                       label="&moveToFolderAgain.label;"/>
        <toolbarseparator id="appmenu_messageMenuAfterMoveCommandsSeparator"/>
        <toolbarbutton id="appmenu_createFilter"
                       class="subviewbutton subviewbutton-iconic"
                       label="&createFilter.label;"
                       command="cmd_createFilterFromMenu"/>
        <toolbarseparator id="appmenu_threadItemsSeparator"/>
        <toolbarbutton label="&killThreadMenu.label;"
                       id="appmenu_killThread"
                       class="subviewbutton subviewbutton-iconic"
                       key="key_killThread"
                       type="checkbox"
                       command="cmd_killThread"/>
        <toolbarbutton label="&killSubthreadMenu.label;"
                       id="appmenu_killSubthread"
                       class="subviewbutton subviewbutton-iconic"
                       key="key_killSubthread"
                       type="checkbox"
                       command="cmd_killSubthread"/>
        <toolbarbutton label="&watchThreadMenu.label;"
                       id="appmenu_watchThread"
                       class="subviewbutton subviewbutton-iconic"
                       key="key_watchThread"
                       type="checkbox"
                       command="cmd_watchThread"/>
      </vbox>
    </panelview>

    <!-- Message / Forward As -->
    <panelview id="appMenu-messageForwardAsView"
               title="&forwardAsMenu.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_forwardAsInline"
                       class="subviewbutton subviewbutton-iconic"
                       label="&forwardAsInline.label;"
                       command="cmd_forwardInline"/>
        <toolbarbutton id="appmenu_forwardAsAttachment"
                       class="subviewbutton subviewbutton-iconic"
                       label="&forwardAsAttachmentCmd.label;"
                       command="cmd_forwardAttachment"/>
      </vbox>
    </panelview>

    <!-- Message / When Opening Feed Messages -->
    <panelview id="appMenu-messageOpenFeedView"
               title="&openFeedMessage1.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_openFeedWebPage"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="openFeedGroup"
                       label="&openFeedWebPage.label;"
                       oncommand="FeedMessageHandler.onOpenPref = 0"/>
        <toolbarbutton id="appmenu_openFeedSummary"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="openFeedGroup"
                       label="&openFeedSummary.label;"
                       oncommand="FeedMessageHandler.onOpenPref = 1"/>
        <toolbarbutton id="appmenu_openFeedWebPageInMessagePane"
                       class="subviewbutton subviewbutton-iconic"
                       type="radio"
                       name="openFeedGroup"
                       label="&openFeedWebPageInMP.label;"
                       oncommand="FeedMessageHandler.onOpenPref = 2"/>
      </vbox>
    </panelview>

    <!-- Message / Tag -->
    <panelview id="appMenu-messageTagView"
               title="&tagMenu.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_addNewTag"
                       class="subviewbutton subviewbutton-iconic"
                       label="&addNewTag.label;"
                       command="cmd_addTag"/>
        <toolbarbutton id="appmenu_manageTags"
                       class="subviewbutton subviewbutton-iconic"
                       label="&manageTags.label;"
                       command="cmd_manageTags"/>
        <toolbarseparator id="appmenu_tagMenu-sep-afterTagAddNew"/>
        <!-- Label for remove all tags is dynamically set. -->
        <toolbarbutton id="appmenu_tagMenu-tagRemoveAll"
                       class="subviewbutton subviewbutton-iconic"
                       command="cmd_removeTags"/>
        <toolbarseparator id="appmenu_tagMenuAfterRemoveSeparator"/>
        <!-- Tag items are dynamically added here. -->
      </vbox>
    </panelview>

    <!-- Message / Mark -->
    <panelview id="appMenu-messageMarkView"
               title="&markMenu.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_markReadMenuItem"
                       class="subviewbutton subviewbutton-iconic"
                       label="&markAsReadCmd.label;"
                       key="key_toggleRead"
                       command="cmd_markAsRead"/>
        <toolbarbutton id="appmenu_markUnreadMenuItem"
                       class="subviewbutton subviewbutton-iconic"
                       label="&markAsUnreadCmd.label;"
                       key="key_toggleRead"
                       command="cmd_markAsUnread"/>
        <toolbarbutton id="appmenu_markThreadAsRead"
                       class="subviewbutton subviewbutton-iconic"
                       label="&markThreadAsReadCmd.label;"
                       key="key_markThreadAsRead"
                       command="cmd_markThreadAsRead"/>
        <toolbarbutton id="appmenu_markReadByDate"
                       class="subviewbutton subviewbutton-iconic"
                       label="&markReadByDateCmd.label;"
                       key="key_markReadByDate"
                       command="cmd_markReadByDate"/>
        <toolbarbutton id="appmenu_markAllRead"
                       class="subviewbutton subviewbutton-iconic"
                       label="&markAllReadCmd.label;"
                       key="key_markAllRead"
                       command="cmd_markAllRead"/>
        <toolbarseparator id="markMenuAfterAllReadSeparator"/>
        <toolbarbutton id="appmenu_markFlaggedMenuItem"
                       class="subviewbutton subviewbutton-iconic"
                       type="checkbox"
                       label="&markStarredCmd.label;"
                       key="key_toggleFlagged"
                       command="cmd_markAsFlagged"/>
        <toolbarseparator id="markMenuAfterFlaggedSeparator"/>
        <toolbarbutton id="appmenu_markAsJunk"
                       class="subviewbutton subviewbutton-iconic"
                       label="&markAsJunkCmd.label;"
                       key="key_markJunk"
                       command="cmd_markAsJunk"/>
        <toolbarbutton id="appmenu_markAsNotJunk"
                       class="subviewbutton subviewbutton-iconic"
                       label="&markAsNotJunkCmd.label;"
                       key="key_markNotJunk"
                       command="cmd_markAsNotJunk"/>
        <toolbarbutton id="appmenu_recalculateJunkScore"
                       class="subviewbutton subviewbutton-iconic"
                       label="&recalculateJunkScoreCmd.label;"
                       command="cmd_recalculateJunkScore"/>
      </vbox>
    </panelview>

    <!-- Message / Move To -->
    <!-- toolbarbuttons are dynamically added by folder-panelview custom element. -->
    <panelview is="folder-panelview" id="appMenu-messageMoveToView"
               title="&moveMsgToMenu.label;"
               class="PanelUI-subView"
               oncommand="MsgMoveMessage(event.target._folder)"
               mode="filing"
               showFileHereLabel="true"
               showRecent="true"
               recentLabel="&moveCopyMsgRecentMenu.label;"
               showFavorites="true"
               favoritesLabel="&contextMoveCopyMsgFavoritesMenu.label;"
               favoritesAccessKey="&contextMoveCopyMsgFavoritesMenu.accesskey;"/>

    <!-- Message / Copy To -->
    <!-- toolbarbuttons are dynamically added by folder-panelview custom element. -->
    <panelview is="folder-panelview" id="appMenu-messageCopyToView"
               title="&copyMsgToMenu.label;"
               class="PanelUI-subView"
               oncommand="MsgCopyMessage(event.target._folder)"
               mode="filing"
               showFileHereLabel="true"
               showRecent="true"
               recentLabel="&moveCopyMsgRecentMenu.label;"
               showFavorites="true"
               favoritesLabel="&contextMoveCopyMsgFavoritesMenu.label;"
               favoritesAccessKey="&contextMoveCopyMsgFavoritesMenu.accesskey;"/>

    <!-- Tools -->
    <panelview id="appMenu-toolsView"
               title="&tasksMenu.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton hidden="true"
                       id="appmenu_tasksMenuMail"
                       class="subviewbutton subviewbutton-iconic"
                       label="&messengerCmd.label;"
                       key="key_mail"
                       oncommand="toMessengerWindow();"/>
        <toolbarbutton id="appmenu_addressBook"
                       class="subviewbutton subviewbutton-iconic"
                       label="&addressBookCmd.label;"
                       key="key_addressbook"
                       oncommand="toAddressBook();"/>
        <toolbarseparator id="devToolsSeparator"/>
        <toolbarbutton id="appmenu_filtersCmd"
                       class="subviewbutton subviewbutton-iconic"
                       label="&filtersCmd2.label;"
                       command="cmd_displayMsgFilters"/>
        <toolbarbutton id="appmenu_applyFilters"
                       class="subviewbutton subviewbutton-iconic"
                       label="&filtersApply.label;"
                       command="cmd_applyFilters"/>
        <toolbarbutton id="appmenu_applyFiltersToSelection"
                       class="subviewbutton subviewbutton-iconic"
                       label="&filtersApplyToMessage.label;"
                       command="cmd_applyFiltersToSelection"/>
        <toolbarseparator/>
        <toolbarbutton id="appmenu_runJunkControls"
                       class="subviewbutton subviewbutton-iconic"
                       label="&runJunkControls.label;"
                       command="cmd_runJunkControls"/>
        <toolbarbutton id="appmenu_deleteJunk"
                       class="subviewbutton subviewbutton-iconic"
                       label="&deleteJunk.label;"
                       command="cmd_deleteJunk"/>
        <toolbarseparator id="tasksMenuAfterDeleteSeparator"/>
        <toolbarbutton id="appmenu_openSavedFilesWnd"
                       class="subviewbutton subviewbutton-iconic"
                       label="&savedFiles.label;"
                       key="key_savedFiles"
                       oncommand="openSavedFilesWnd();"/>
        <toolbarbutton id="appmenu_imAccountsStatus"
                       class="subviewbutton subviewbutton-nav"
                       label="&imAccountsStatus.label;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-toolsChatStatusView', this)"/>
        <toolbarbutton id="appmenu_joinChatMenuItem"
                       class="subviewbutton subviewbutton-iconic"
                       label="&joinChatCmd.label;"
                       command="cmd_joinChat"/>
        <toolbarseparator id="appmenu_afterChatSeparator"/>
        <toolbarbutton id="appmenu_import"
                       class="subviewbutton subviewbutton-iconic"
                       label="&importCmd.label;"
                       oncommand="toImport();"/>
        <toolbarbutton id="appmenu_export"
                       class="subviewbutton subviewbutton-iconic"
                       label="&exportCmd.label;"
                       oncommand="toExport();"/>
        <toolbarbutton id="appmenu_manageKeysOpenPGP"
                       class="subviewbutton subviewbutton-iconic"
                       data-l10n-id="openpgp-manage-keys-openpgp-cmd"
                       oncommand="openKeyManager()"/>
        <toolbarbutton id="appmenu_devtoolsMenu"
                       class="subviewbutton subviewbutton-nav"
                       label="&devtoolsMenu.label;"
                       accesskey="&devtoolsMenu.accesskey;"
                       closemenu="none"
                       oncommand="PanelUI.showSubView('appMenu-toolsDevtoolsView', this)"/>
        <toolbarbutton id="appmenu_sanitizeHistory"
                       class="subviewbutton subviewbutton-iconic"
                       label="&clearRecentHistory.label;"
                       key="key_sanitizeHistory"
                       oncommand="toSanitize();"/>
        <toolbarseparator/>
        <toolbarbutton id="appmenu_activityManager"
                       class="subviewbutton subviewbutton-iconic"
                       label="&activitymanager.label;"
                       oncommand="openActivityMgr();"/>
      </vbox>
    </panelview>

    <!-- Tools / Chat Status -->
    <panelview id="appMenu-toolsChatStatusView"
               title="&imAccountsStatus.label;"
               class="PanelUI-subView"
               command="cmd_chatStatus">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_imStatusAvailable"
                       class="subviewbutton subviewbutton-iconic"
                       status="available"
                       label="&imStatus.available;"/>
        <toolbarbutton id="appmenu_imStatusUnavailable"
                       class="subviewbutton subviewbutton-iconic"
                       status="unavailable"
                       label="&imStatus.unavailable;"/>
        <toolbarseparator id="appmenu_imStatusOfflineSeparator"/>
        <toolbarbutton id="appmenu_imStatusOffline"
                       class="subviewbutton subviewbutton-iconic"
                       status="offline"
                       label="&imStatus.offline;"/>
        <toolbarseparator id="appmenu_imStatusShowAccountsSeparator"/>
        <toolbarbutton id="appmenu_imStatusShowAccounts"
                       class="subviewbutton subviewbutton-iconic"
                       label="&imStatus.showAccounts;"/>
      </vbox>
    </panelview>

    <!-- Tools / Developer Tools -->
    <panelview id="appMenu-toolsDevtoolsView"
               title="&devtoolsMenu.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_devtoolsToolbox"
                       class="subviewbutton subviewbutton-iconic"
                       label="&devToolboxCmd.label;"
                       accesskey="&devToolboxCmd.accesskey;"
                       key="key_devtoolsToolbox"
                       oncommand="BrowserToolboxLauncher.init();"/>
        <toolbarbutton id="appmenu_addonDebugging"
                       class="subviewbutton subviewbutton-iconic"
                       label="&debugAddonsCmd.label;"
                       accesskey="&debugAddonsCmd.accesskey;"
                       oncommand="openAboutDebugging('addons')"/>
        <toolbarseparator id="appmenu_debuggingSeparator"/>
        <toolbarbutton id="appmenu_javascriptConsole"
                       class="subviewbutton subviewbutton-iconic"
                       label="&errorConsoleCmd.label;"
                       accesskey="&errorConsoleCmd.accesskey;"
                       key="key_errorConsole"
                       oncommand="toJavaScriptConsole();"/>
      </vbox>
    </panelview>

    <!-- Help -->
    <panelview id="appMenu-helpView"
               title="&helpMenuWin.label;"
               class="PanelUI-subView">
      <vbox class="panel-subview-body">
        <toolbarbutton id="appmenu_openHelp"
                       class="subviewbutton subviewbutton-iconic"
                       label="&productHelp.label;"
                       key="key_openHelp"
                       oncommand="openSupportURL();"/>
        <toolbarbutton id="menu_keyboardShortcuts"
                       class="subviewbutton subviewbutton-iconic"
                       label="&helpKeyboardShortcuts.label;"
                       oncommand="openLinkText(event, 'keyboardShortcutsURL');"/>
        <toolbarseparator/>
        <toolbarbutton id="getInvolved"
                       class="subviewbutton subviewbutton-iconic"
                       label="&helpGetInvolvedPage.label;"
                       oncommand="openLinkText(event, 'getInvolvedURL');"/>
        <toolbarbutton id="donationsPage"
                       class="subviewbutton subviewbutton-iconic"
                       label="&helpDonationsPage.label;"
                       oncommand="openLinkText(event, 'donateURL');"/>
        <toolbarbutton id="feedbackPage"
                       class="subviewbutton subviewbutton-iconic"
                       label="&helpFeedbackPage.label;"
                       oncommand="openLinkText(event, 'feedbackURL');"/>
        <toolbarseparator/>
        <toolbarbutton id="appmenu_troubleshootMode"
                       class="subviewbutton subviewbutton-iconic"
                       data-l10n-id="appmenu-help-enter-troubleshoot-mode"
                       oncommand="safeModeRestart();"/>
        <toolbarbutton id="appmenu_troubleshootingInfo"
                       class="subviewbutton subviewbutton-iconic"
                       data-l10n-id="appmenu-help-more-troubleshooting-info"
                       oncommand="openAboutSupport();"/>
        <toolbarseparator/>
        <toolbarbutton id="appmenu_about"
                       class="subviewbutton subviewbutton-iconic"
                       label="&aboutProduct2.label;"
                       oncommand="openAboutDialog();"/>
      </vbox>
    </panelview>

#ifdef MAIN_WINDOW
#include ../../../../calendar/base/content/calendar-appmenu-panelviews.inc.xhtml
#endif

  </panelmultiview>
</panel>
